from __future__ import annotations

from collections.abc import Mapping
from typing import TYPE_CHECKING, Any, TypeVar, cast

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..models.module_config_data_type import ModuleConfigDataType
from ..types import UNSET, Unset

if TYPE_CHECKING:
    from ..models.module_config_default import ModuleConfigDefault


T = TypeVar("T", bound="ModuleConfig")


@_attrs_define
class ModuleConfig:
    """
    Attributes:
        label (str | Unset):
        required (bool | Unset):
        hint (str | Unset):
        options (list[str] | Unset):
        data_type (ModuleConfigDataType | Unset):
        language (str | Unset):
        default (ModuleConfigDefault | Unset):
        height (str | Unset):
        source (str | Unset):
    """

    label: str | Unset = UNSET
    required: bool | Unset = UNSET
    hint: str | Unset = UNSET
    options: list[str] | Unset = UNSET
    data_type: ModuleConfigDataType | Unset = UNSET
    language: str | Unset = UNSET
    default: ModuleConfigDefault | Unset = UNSET
    height: str | Unset = UNSET
    source: str | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        label = self.label

        required = self.required

        hint = self.hint

        options: list[str] | Unset = UNSET
        if not isinstance(self.options, Unset):
            options = self.options

        data_type: str | Unset = UNSET
        if not isinstance(self.data_type, Unset):
            data_type = self.data_type.value

        language = self.language

        default: dict[str, Any] | Unset = UNSET
        if not isinstance(self.default, Unset):
            default = self.default.to_dict()

        height = self.height

        source = self.source

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if label is not UNSET:
            field_dict["label"] = label
        if required is not UNSET:
            field_dict["required"] = required
        if hint is not UNSET:
            field_dict["hint"] = hint
        if options is not UNSET:
            field_dict["options"] = options
        if data_type is not UNSET:
            field_dict["dataType"] = data_type
        if language is not UNSET:
            field_dict["language"] = language
        if default is not UNSET:
            field_dict["default"] = default
        if height is not UNSET:
            field_dict["height"] = height
        if source is not UNSET:
            field_dict["source"] = source

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        from ..models.module_config_default import ModuleConfigDefault

        d = dict(src_dict)
        label = d.pop("label", UNSET)

        required = d.pop("required", UNSET)

        hint = d.pop("hint", UNSET)

        options = cast(list[str], d.pop("options", UNSET))

        _data_type = d.pop("dataType", UNSET)
        data_type: ModuleConfigDataType | Unset
        if isinstance(_data_type, Unset):
            data_type = UNSET
        else:
            data_type = ModuleConfigDataType(_data_type)

        language = d.pop("language", UNSET)

        _default = d.pop("default", UNSET)
        default: ModuleConfigDefault | Unset
        if isinstance(_default, Unset):
            default = UNSET
        else:
            default = ModuleConfigDefault.from_dict(_default)

        height = d.pop("height", UNSET)

        source = d.pop("source", UNSET)

        module_config = cls(
            label=label,
            required=required,
            hint=hint,
            options=options,
            data_type=data_type,
            language=language,
            default=default,
            height=height,
            source=source,
        )

        module_config.additional_properties = d
        return module_config

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
